local Constants = require('Constants')

local AndroidDevices = {}

function AndroidDevices:Init()
    AndroidDevices.DevicesByGPU = 
    {
        {
            Primary = "Adreno",
            Secondary = {
                { "200", Constants.VisualQualityLevelLow },
                { "203", Constants.VisualQualityLevelHigh },
                { "205", Constants.VisualQualityLevelLow },
                { "220", Constants.VisualQualityLevelHigh },
                { "225", Constants.VisualQualityLevelHigh },
                { "305", Constants.VisualQualityLevelHigh },
                { "320", Constants.VisualQualityLevelHigh },
                { "330", Constants.VisualQualityLevelHigh },
            },
        },
        {
            Primary = "GeForce",
            Secondary = {
                { "300", Constants.VisualQualityLevelLow },
                { "333", Constants.VisualQualityLevelLow },
                { "400", Constants.VisualQualityLevelLow },
                { "400", Constants.VisualQualityLevelLow },
                { "416", Constants.VisualQualityLevelHigh },
                { "520", Constants.VisualQualityLevelHigh },
                { "520", Constants.VisualQualityLevelHigh },
                { "520", Constants.VisualQualityLevelHigh },
                { "672", Constants.VisualQualityLevelHigh },
            }, 
        },    
        {
            Primary = "PowerVR",
            Secondary = {
                { "530", Constants.VisualQualityLevelLow },
                { "535", Constants.VisualQualityLevelLow },
                { "540", Constants.VisualQualityLevelLow },
                { "544", Constants.VisualQualityLevelHigh },
                { "545", Constants.VisualQualityLevelLow },
            }, 
        },        
        {
            Primary = "VideoCore",
            Secondary = {
                { "1", Constants.VisualQualityLevelLow },
                { "2", Constants.VisualQualityLevelLow },
                { "3", Constants.VisualQualityLevelLow },
                { "4", Constants.VisualQualityLevelLow },
            }, 
        },          
        {
            Primary = "Mali",
            Secondary = {
                { "400", Constants.VisualQualityLevelLow },
                { "604", Constants.VisualQualityLevelHigh },
            }, 
        },   
    }
    
    AndroidDevices.MiscDevices = 
    {    
        { "Tegra 2", Constants.VisualQualityLevelLow },				
        { "Tegra2", Constants.VisualQualityLevelLow },				
        { "Tegra 3", Constants.VisualQualityLevelHigh },				
        { "Tegra3", Constants.VisualQualityLevelHigh },							
        { "Tegra 4", Constants.VisualQualityLevelHigh },	        
        { "Tegra4", Constants.VisualQualityLevelHigh },	        
        { "OMAP", Constants.VisualQualityLevelLow },	        
        { "BCM", Constants.VisualQualityLevelLow },	        
    }
    
    AndroidDevices.LowPerformanceAudioDevices = 
    {
        "Kindle Fire",
    }
end

--[[
                REFERENCE
    
local AndroidDevices = {
        --Model     GPU     Setting					
--Snapdragon S1					
    { "MSM7225", "<none>", Constants.VisualQualityLevelLow },		
    { "MSM7625", "<none>", Constants.VisualQualityLevelLow },				
    { "MSM7227", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7627", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7225A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7625A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7227A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7627A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "QSD8250", "Adreno 200", Constants.VisualQualityLevelLow },			 	
    { "QSD8650", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7200", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7200A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7201", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7201A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7500", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7500A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7501", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7501A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7600", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7600A", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7601", "Adreno 200", Constants.VisualQualityLevelLow },				
    { "MSM7601A", "Adreno 200", Constants.VisualQualityLevelLow },				
					
--Snapdragon S2					
    { "MSM7230", "Adreno 205", Constants.VisualQualityLevelLow },				
    { "MSM7630", "Adreno 205", Constants.VisualQualityLevelLow },				
    { "APQ8055", "Adreno 205", Constants.VisualQualityLevelLow },				
    { "MSM8255", "Adreno 205", Constants.VisualQualityLevelLow },				
    { "MSM8655", "Adreno 205", Constants.VisualQualityLevelLow },				
				
--Snapdragon S3			
    { "APQ8060", "Adreno 220", Constants.VisualQualityLevelHigh },				
    { "MSM8260", "Adreno 220", Constants.VisualQualityLevelHigh },				
    { "MSM8660", "Adreno 220", Constants.VisualQualityLevelHigh },				
    					
--Snapdragon S4					
    { "MSM8225", "Adreno 203", Constants.VisualQualityLevelHigh },				
    { "MSM8625", "Adreno 203", Constants.VisualQualityLevelHigh },				
    { "MSM8225Q", "Adreno 203", Constants.VisualQualityLevelHigh },				
    { "MSM8625Q", "Adreno 203", Constants.VisualQualityLevelHigh },				
    { "MSM8627", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "MSM8627", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "APQ8030", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "MSM8230", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "MSM8630", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "MSM8930", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "APQ8060A", "Adreno 225", Constants.VisualQualityLevelHigh },				
    { "MSM8260A", "Adreno 225", Constants.VisualQualityLevelHigh },				
    { "MSM8660A", "Adreno 225", Constants.VisualQualityLevelHigh },				
    { "MSM8960", "Adreno 225", Constants.VisualQualityLevelHigh },				
    { "MSM8960T", "Adreno 320", Constants.VisualQualityLevelHigh },				
    { "APQ8064", "Adreno 320", Constants.VisualQualityLevelHigh },				
    { "MPQ8064", "Adreno 320", Constants.VisualQualityLevelHigh },				
					
--Snapdragon 200			
    { "8225Q", "Adreno 203", Constants.VisualQualityLevelHigh },				
    { "8625Q", "Adreno 203", Constants.VisualQualityLevelHigh },				
					
--Snapdragon 400					
    { "8226", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8626", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8926", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8230", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8630", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8930", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8030AB", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8230AB", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8630AB", "Adreno 305", Constants.VisualQualityLevelHigh },				
    { "8930AB", "Adreno 305", Constants.VisualQualityLevelHigh },				
			
--Snapdragon 600			
    { "8064T", "Adreno 320", Constants.VisualQualityLevelHigh },				
				
--Snapdragon 800					
    { "8074", "Adreno 330", Constants.VisualQualityLevelHigh },				
    { "8274", "Adreno 330", Constants.VisualQualityLevelHigh },				
    { "8674", "Adreno 330", Constants.VisualQualityLevelHigh },				
    { "8974", "Adreno 330", Constants.VisualQualityLevelHigh },				
				
--Tegra 2			
    { "Tegra 250 AP20H (Ventana)", "ULP GeForce 300 MHz", Constants.VisualQualityLevelLow },				
    { "Tegra 250 T20 (Harmony)", "ULP GeForce 333 MHz", Constants.VisualQualityLevelLow },			
    { "Tegra 250 3D AP25", "ULP GeForce 400 MHz", Constants.VisualQualityLevelLow },			
    { "Tegra 250 3D T25", "ULP GeForce 400 MHz", Constants.VisualQualityLevelLow },			
				
--Tegra 3					
    { "Tegra 3 T30", "416 MHz ULP GeForce", Constants.VisualQualityLevelHigh },				
    { "Tegra 3 T30", "520 MHz ULP GeForce", Constants.VisualQualityLevelHigh },				
    { "Tegra 3 AP33", "520 MHz ULP GeForce", Constants.VisualQualityLevelHigh },				
    { "Tegra 3 T33", "520 MHz ULP GeForce", Constants.VisualQualityLevelHigh },				

--Tegra 4			
    { "Tegra 4 Wayne", "GeForce @ 72 Core, 672MHz", Constants.VisualQualityLevelHigh },				
				
--OMAP 1					
    { "OMAP171x", "<none>", Constants.VisualQualityLevelLow },						
    { "OMAP162x", "<none>", Constants.VisualQualityLevelLow },					
    { "OMAP5912", "<none>", Constants.VisualQualityLevelLow },						
    { "OMAP161x", "<none>", Constants.VisualQualityLevelLow },						
    { "OMAP1510", "<none>", Constants.VisualQualityLevelLow },						
    { "OMAP5910", "<none>", Constants.VisualQualityLevelLow },						
				
--OMAP 2				
    { "OMAP2431", "<none>", Constants.VisualQualityLevelLow },						
    { "OMAP2430", "<none>", Constants.VisualQualityLevelLow },						
    { "OMAP2420", "<none>", Constants.VisualQualityLevelLow },						
					
--OMAP 3					
    { "OMAP3410", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3420", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3430", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3440", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3503", "<none>", Constants.VisualQualityLevelLow },				
    { "OMAP3515", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3525", "<none>", Constants.VisualQualityLevelLow },				
    { "OMAP3530", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3611", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3621", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3622", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3630", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
    { "OMAP3640", "PowerVR SGX530", Constants.VisualQualityLevelLow },			
					
--OMAP 4					
    { "OMAP4430", "PowerVR SGX540", Constants.VisualQualityLevelHigh },	 			
    { "OMAP4460", "PowerVR SGX540", Constants.VisualQualityLevelHigh },	 			
    { "OMAP4470", "PowerVR SGX544", Constants.VisualQualityLevelHigh },				
				
--OMAP 5			
    { "OMAP5430", "PowerVR SGX544MP2", Constants.VisualQualityLevelHigh },				
    { "OMAP5432", "PowerVR SGX544MP2", Constants.VisualQualityLevelHigh },				
					
--Broadcom					
    { "VC01", "VideoCore 1", Constants.VisualQualityLevelLow },			
    { "BCM2702", "VideoCore 2", Constants.VisualQualityLevelLow },			
    { "BCM2705", "VideoCore 2", Constants.VisualQualityLevelLow },			
    { "BCM2722", "VideoCore 2", Constants.VisualQualityLevelLow },			
    { "BCM2724", "VideoCore 2", Constants.VisualQualityLevelLow },			
    { "BCM2727", "VideoCore 3", Constants.VisualQualityLevelLow },			
    { "BCM11181", "VideoCore 3", Constants.VisualQualityLevelLow },			
    { "BCM2763", "VideoCore 4", Constants.VisualQualityLevelLow },			
    { "BCM2820", "VideoCore 4", Constants.VisualQualityLevelLow },			
    { "BCM2835", "VideoCore 4", Constants.VisualQualityLevelLow },			
    { "BCM11182", "VideoCore 4", Constants.VisualQualityLevelLow },			
    { "BCM11311", "VideoCore 4", Constants.VisualQualityLevelLow },			
    { "BCM21654", "VideoCore 4", Constants.VisualQualityLevelLow },			
    { "BCM28150", "VideoCore 4", Constants.VisualQualityLevelLow },			
    { "BCM21553", "VideoCore 4", Constants.VisualQualityLevelLow },			
				
--Atom					
    { "Atom Z2420", "PowerVR SGX 540", Constants.VisualQualityLevelLow },			
    { "Atom Z2460", "PowerVR SGX 540", Constants.VisualQualityLevelLow },			
    { "Atom Z2480", "PowerVR SGX 540", Constants.VisualQualityLevelLow },			
    { "Atom Z2760", "PowerVR SGX 545", Constants.VisualQualityLevelLow },			
    { "Atom Z2520", "PowerVR SGX 544", Constants.VisualQualityLevelLow },			
    { "Atom Z2560", "PowerVR SGX 544", Constants.VisualQualityLevelLow },			
    { "Atom Z2580", "PowerVR SGX 544", Constants.VisualQualityLevelLow },			
				
--Samsung					
    { "S5PC110", "PowerVR SGX540", Constants.VisualQualityLevelLow },
    { "Exynos 3110", "Mali-400", Constants.VisualQualityLevelLow },
    { "Exynos 4210", "Mali-400", Constants.VisualQualityLevelLow },
    { "Exynos 4212", "Mali-400", Constants.VisualQualityLevelHigh },	
    { "Exynos 4412", "Mali-T604", Constants.VisualQualityLevelHigh },	
    { "Exynos 5250", "PowerVR SGX544MP3", Constants.VisualQualityLevelHigh },	
				
--NovaThor
    { "NovaThor U8500", "ARM Mali 400", Constants.VisualQualityLevelLow },			
    { "NovaThor U9500", "ARM Mali 400", Constants.VisualQualityLevelLow },			
    { "Nova A9500", "ARM Mali 400", Constants.VisualQualityLevelLow },			
}
--]]

return AndroidDevices