local Constants = require("Constants")
local DFGraphics = require("DFCommon.Graphics")

local AudioRing = {}

function AudioRing:Init( rRenderer )
    AudioRing.rLayer = rRenderer.mGameLayer

    AudioRing.mDeck = AudioRingDeck.new()
    
    local texture = DFGraphics.loadTexture("Effects/Textures/AudioBarEdge", false )
    AudioRing.mDeck:setTexture( texture )
    
    AudioRing.mMount = MOAIProp2D.new()
    AudioRing.mMount:setLoc(0, 0)
    AudioRing.mMount:setDeck(AudioRing.mDeck)
    
    self:Enable(false)
    
    
    --[[
    local quadDeck = QuadBatchDeck.new()
    local quadTexture = DFGraphics.loadTexture("Effects/Textures/Flow", false)
    quadDeck:setTexture(quadTexture)
    local quadMount = MOAIProp2D.new()
    quadMount:setLoc(0, 0)
    quadMount:setDeck(quadDeck)
    
    quadDeck:ReserveQuads(1)
    quadDeck:SetQuadPosition(1, 100.0, -100.0, 0.0)
    quadDeck:SetQuadRotation(1, 0.0, 0.0, 0.0)
    quadDeck:SetQuadScale(1, 200.0, 200.0)
    
    AudioRing.rLayer:insertProp(quadMount)
    ]]--
end

function AudioRing:Update()
    if AudioRing.mIsEnabled then
        AudioRing.mMount:setLoc(-Constants.ValidDrawHalfWidth, Constants.ValidDrawHalfHeight)
        AudioRing.mDeck:SetDimensions( Constants.ValidDrawWidth, Constants.ValidDrawHeight, Constants.GameRingRadius )
        AudioRing.mDeck:Update()
    end
end

function AudioRing:SetRingOffset(fOffset)
    AudioRing.mDeck:SetRingOffset(fOffset)
end

function AudioRing:SetScale(fScale)
    AudioRing.mDeck:SetScale(fScale)
end

function AudioRing:SetMaxScale(fMaxScale)
    AudioRing.mDeck:SetMaxScale(fMaxScale)
end

function AudioRing:SetColor(r,g,b,a)
    AudioRing.mDeck:SetColor(r,g,b,a)
end

function AudioRing:Enable(bEnable)
    --bEnable = true

    if bEnable ~= AudioRing.mIsEnabled then
        AudioRing.mIsEnabled = bEnable
        
        if bEnable then
            AudioRing.rLayer:insertProp(AudioRing.mMount)        
        else
            AudioRing.rLayer:removeProp(AudioRing.mMount)
        end
    end
end

return AudioRing