local Constants = {}

function Constants:Init()
    Constants.IsMobile = (MOAIEnvironment.osBrand == "iOS") or (MOAIEnvironment.osBrand == "Android")

    Constants.VisualQualityLevelUltra = 3
    Constants.VisualQualityLevelHigh = 2
    Constants.VisualQualityLevelLow = 1
    Constants.VisualQualityUninitialized = -1
    Constants.UseLowPerformanceAudio = false
    
    Constants.DefaultVisualQuality = Constants.VisualQualityLevelHigh
    Constants.DesiredVisualQuality = Constants.DefaultVisualQuality
    Constants.VisualQuality = Constants.DesiredVisualQuality
    --Constants.OverrideVisualStyle = "level4" -- values like "level8", "leaderboards", "intro"
    
    Constants.ValidDrawWidth = 1280.0
    Constants.ValidDrawHeight = 720.0
    Constants.ValidDrawHalfWidth = Constants.ValidDrawWidth * .5
    Constants.ValidDrawHalfHeight = Constants.ValidDrawHeight * .5
    
    Constants.NativeScreenWidth = 1.0
    Constants.NativeScreenHeight = 1.0
    
    Constants.ScreenBufferMaxWidth_Low = 640.0
    Constants.ScreenBufferMaxHeight_Low = 720.0
    Constants.ScreenBufferMaxWidth_High = 1024.0
    Constants.ScreenBufferMaxHeight_High = 512.0

    Constants.FrameRate_Low = 30.0
    Constants.FrameRate_High = 60.0 
    
    Constants.MinAspectRatio = 1280.0 / 720.0 -- the most "square" you want it to support.

    Constants.UpdateScreenBufferSize()
    
    Constants.GameRingRadius = Constants.ValidDrawHalfHeight
    Constants.PatternPositionScalar = 0.75
    Constants.GlobalScale = 1.0
    
    Constants.UpdateFramerate()
    
    Constants.TouchBotEnabled = false
    
    Constants.mPaused = false
        
    Constants.ShowDebugInfo = DFRad.IsDevBuild()
    Constants.ShowFullProfilingInfo = false
    Constants.ShowGPUProfilingInfo = false
    
    Constants.ForwardVector = {1.0, 0.0}
    Constants.SmallFloat = 0.001

    Constants.UseAudio = true
    Constants.UseSFX = true
    Constants.UsePostEffects = true
    Constants.UsePostEffectDebugInput = false
    Constants.UseParticleEffects = true
    Constants.UseMouseInput = true
    Constants.AllowPause = true
    Constants.SkipMainMenu = false
    Constants.AllowSkipAllLevels = false
    
    Constants.ThrowUnlocked = false
    Constants.FullMixMode = false
        
    Constants.FilterFreqLimit = 22000.0
    Constants.BeatScale = 2.0
    Constants.BeatActive = false
    Constants.BeatDuration = 0.46875
    Constants.BeatProgress = 0.0
    Constants.Heartbeat = 0.0
    
    Constants.MusicStateLoad = -1
    Constants.MusicStateIntro = 0
    Constants.MusicStateLoop = 1
    Constants.MusicStateBuilding = 2
    Constants.MusicStateBonus = 3
    Constants.MusicStateComplete = 4
    Constants.MusicStateEnd = 4
    Constants.MusicState = Constants.MusicStateLoad

    Constants.tAudioSpectrum = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0}
    Constants.AudioSpectrumSmoothValue = 0.0
    Constants.AudioSpectrumAverage = 0.0
    Constants.AudioSpectrumNumValues = 64
    
    Constants.BGColor = {0, 0, 0}
    Constants.Color1 = {1, 0, 0}
    Constants.Color2 = {0, 0, 0}
    Constants.Color3 = {0, 0, 0}
    Constants.SpecialColor = {0.95, 0.95, 0.95}
    
    Constants.LetterboxColor = {0.0, 0.0, 0.0, 1.0}
    
    Constants.GoodEffectColor = {0.4, 0.2, 1.0, 1.0}
    Constants.BadEffectColor = {1.0, 0.0, 0.0, 1.0}
    Constants.GeneralRed = {0.8, 0.1, 0.1, 1.0}
    
    Constants.ColorModeIntro = 0
    Constants.ColorModeInGame = 1
    Constants.ColorMode = Constants.ColorModeIntro

    Constants.BasePenWidth = 2.0

    Constants.NumGameInputs = 12
    
    Constants.SwipeSpeedScalar = math.pi * 3.5
    Constants.SwipeSpeedMin = math.pi 
    Constants.SwipeSpeedMax = math.pi * 4.0 
    Constants.ThrowSpeedThreshold = 0.25
    Constants.ThrowRotationDecay = math.pi
        
    Constants.GameStateTitle = 0
    Constants.GameStateStartup = 1
    Constants.GameStatePreIntro = 2
    Constants.GameStateIntro = 3
    Constants.GameStateMenu = 4
    Constants.GameStateInGame = 5
    Constants.GameStateComplete = 6
    Constants.GameStatePost = 7
    Constants.GameStateLeaderboardEntry = 8
    Constants.GameStateLeaderboardShowcase = 9    
    Constants.GameStateCredits = 10
    Constants.GameStateHowToPlay = 11
    Constants.GameStateExit = 12
    Constants.GameStatePerformanceTest = 13
    
    Constants.GameState = Constants.GameStateStartup   
    Constants.DesiredGameState = Constants.GameStateStartup   

    --[[
    1 -introduce bits, bads
    2 -tilt horiz
    3 -introduce hold
    4 -hold + standard
    5 -tilt vert
    6 -introduce throw
    7 -throw + standard
    8 -tilt both
    9 -all
    0 -final level (hard)    
    --]]    
    Constants.CurrentGameLevel = 1
    Constants.NumGameLevels = 10
    Constants.ThrowTutorialLevel = 6
    Constants.HoldTutorialLevel = 3
    Constants.PointHorizLevel = 2
    Constants.PointVertLevel = 5
    Constants.PointBothLevel = 8
    Constants.HardHoldLevel = 4
    Constants.HardThrowLevel = 7
    Constants.AllLevel = 9
    
    Constants.MaxLevelIndex = 11
    Constants.VisualQualityIndex = 12
    Constants.FirstTimePlay = true
    
    Constants.Leaderboards = {}
    Constants.LeaderboardCount = 10
    Constants.LeaderboardIndex = -1
    Constants.LeaderboardHighScore = 0
    Constants.PreviousGameScore = 0
    Constants.PreviousGameInitials = "!!!"
    Constants.MaxCompletedLevel = 0
    
    Constants.IOSLeaderboardID = "dropchordlb"
    
    Constants.LevelStateStart = 1
    Constants.LevelStateBuild = 2
    Constants.LevelStateBonus = 3
    Constants.LevelStateHealth = 4
    Constants.LevelState = Constants.LevelStateStart
    Constants.DesiredLevelState = Constants.LevelStateStart
    Constants.LevelStateSwitchTimer = 0.0
        
    Constants.GameCameraTiltModeNone = 0
    Constants.GameCameraTiltModeTiltHoriz = 1
    Constants.GameCameraTiltModeTiltVert = 2
    Constants.GameCameraTiltModeTiltBoth = 3
    Constants.GameCameraTiltModeTiltBothNoAudio = 4
    Constants.GameCameraTiltMode = Constants.GameCameraTiltModeNone
    Constants.GameCameraTiltDesiredMode = Constants.GameCameraTiltModeNone
    
    Constants.GameIntroChargeActivationDuration = 0.25
    Constants.GameIntroBeamConnectionDuration = 2.0
    
    Constants.ChargeStateDisabled = 0
    Constants.ChargeStateActive = 1
    Constants.ChargeStateThrown = 2
    Constants.ChargeStateNoInput = 3      
    
    --don't change the order of these-- it'll break the level editor
    Constants.BitTypeBad = 0
    Constants.BitTypeGood = 1
    Constants.BitTypeSlice = 2
    Constants.BitTypeFreeze = 3
    Constants.BitTypeHealth = 4
    Constants.BitTypeFanFare = 5
    Constants.BitTypeHold = 6
    Constants.BitTypePoint = 7
 
    Constants.PatternTypeIntro = 0
    Constants.PatternTypeStandard = 1
    Constants.PatternTypeLearnThrow = 2
    Constants.PatternTypeLearnHold = 3
    Constants.PatternTypeBonus = 4   
    Constants.PatternTypeFullMix = 5    
    Constants.PatternTypePointHoriz = 6    
    Constants.PatternTypePointVert = 7 
    Constants.PatternTypePointBoth = 8  
    Constants.PatternTypeComplete = 9
    
    Constants.PatternStateStandard = 0    
    Constants.PatternStateFanfare = 1    
    Constants.PatternStateFail = 2 
        
    Constants.LeaderboardEntryStateEnter = 0
    Constants.LeaderboardEntryStateSelection = 1
    Constants.LeaderboardEntryStateExit = 2
    
    Constants.UINewAbilityStateNone = 0
    Constants.UINewAbilityStateThrow = 1
    
    Constants.mTutorialTypeNone = 0
    Constants.mTutorialTypeBad = 1
    Constants.mTutorialTypePoint = 2
    Constants.mTutorialTypeHold = 3
    Constants.mTutorialTypeThrow = 4
    
    Constants.mTutorialStateNone = 0
    Constants.mTutorialStateEnterTutorial = 1
    Constants.mTutorialStateWaitTutorial = 2
    Constants.mTutorialStateExitTutorial = 3
    
    Constants.mMenuSelectionNone = 0
    Constants.mMenuSelectionPlay = 1
    Constants.mMenuSelectionFreePlay = 2
    Constants.mMenuSelectionLeaders = 3
    Constants.mMenuSelectionOptions = 4
    
    Constants.mMenuSelectionHowToPlay = 1 
    Constants.mMenuSelectionCredits = 2
    Constants.mMenuSelectionVisuals = 3
    Constants.mMenuSelectionMenu = 4
      
    Constants.mMenuSelectionUltra = 1
    Constants.mMenuSelectionHigh = 2
    Constants.mMenuSelectionLow = 3
    Constants.mMenuSelectionBack = 4
    
    Constants.mMenuDrawStateNone = 0
    Constants.mMenuDrawStateIn = 1
    Constants.mMenuDrawStateShow = 2
    Constants.mMenuDrawStateOut = 3
    
    Constants.mMenuDepthMenu = 0
    Constants.mMenuDepthOptions = 1
    Constants.mMenuDepthVisuals = 2
    Constants.mMenuDepthVisualsReset = 3
    
    Constants.mHUDPositionBit = 0
    Constants.mHUDPositionPlay = 1
    Constants.mHUDPositionFullMix = 2
    Constants.mHUDPositionLeaders = 3
    Constants.mHUDPositionHowToPlay = 4
    Constants.mHUDPositionCredits = 5
    Constants.mHUDPositionHold1 = 6
    Constants.mHUDPositionHold2 = 7
    Constants.mHUDPositionOptions = 8
    Constants.mHUDPositionVQ = 9
    Constants.mHUDPositionBack = 10
    Constants.mHUDPositionLow = 11
    Constants.mHUDPositionHigh = 12
    Constants.mHUDPositionUltra = 13
    Constants.mHUDPositionFullScreen = 14
    
    Constants.mHealthStateNone = 0
    Constants.mHealthStateTrackComplete = 1
    Constants.mHealthStatePatterns = 2
    Constants.mHealthStateNumPatterns = 3
    Constants.mHealthStatePerfect = 4
    Constants.mHealthStateNumPerfect = 5
    Constants.mHealthStatePercent = 6
    Constants.mHealthStateHealthUp = 7
    
    Constants.mPauseScreenReturnNone = 0
    Constants.mPauseScreenReturnQuit = 1
    Constants.mPauseScreenReturnNext = 2
    
    Constants.ParticlePriorityLow = 0
    Constants.ParticlePriorityHigh = 1
    
    Constants.MaxParticlesLow = 8
    Constants.MaxParticlesHigh = 12  --don't make this lower than 12 (the intro sequence requires 12)
    
    Constants.Achievements = {
        DA_HighScore = {
            type = 'progressive',
            nNumRequired = 1,
            sGameCenterKey = 'DA_HighScore',
        },
        DA_HighMultiplier = {
            type = 'progressive',
            nNumRequired = 1,
            sGameCenterKey = 'DA_HighMultiplier',
        }, 
        DA_FullSetComplete = {
            type = 'progressive',
            nNumRequired = 1,
            sGameCenterKey = 'DA_FullSetComplete',
        },   
        DA_FullMixMode = {
            type = 'progressive',
            nNumRequired = 1,
            sGameCenterKey = 'DA_FullMixMode',
        },   
        DA_BeamSpin = {
            type = 'progressive',
            nNumRequired = 1,
            sGameCenterKey = 'DA_BeamSpin',
        },   
    }
end

function Constants.UpdateFramerate()
    if Constants.IsMobile or Constants.VisualQuality ~= Constants.VisualQualityLevelUltra then
        Constants.Framerate = Constants.FrameRate_Low
    else
        Constants.Framerate = Constants.FrameRate_High
    end
    
    Constants.InvFramerate = 1.0 / Constants.Framerate
    Constants.FrameStep = Constants.InvFramerate
    
    MOAISim.setStep( Constants.InvFramerate )
end

function Constants.UpdateScreenBufferSize()    
    if Constants.VisualQuality == Constants.VisualQualityLevelUltra then
        Constants.ScreenBufferMaxWidth = Constants.NativeScreenWidth
        Constants.ScreenBufferMaxHeight = Constants.NativeScreenHeight
    elseif Constants.VisualQuality == Constants.VisualQualityLevelHigh then
        Constants.ScreenBufferMaxWidth = Constants.ScreenBufferMaxWidth_High
        Constants.ScreenBufferMaxHeight = Constants.ScreenBufferMaxHeight_High        
    else
        Constants.ScreenBufferMaxWidth = Constants.ScreenBufferMaxWidth_Low
        Constants.ScreenBufferMaxHeight = Constants.ScreenBufferMaxHeight_Low
    end
        
    Constants.ScreenBufferWidth = Constants.ValidDrawWidth
    Constants.ScreenBufferHeight = Constants.ValidDrawHeight
end
return Constants
