local Constants = require('Constants')
local DFUtil = require('DFCommon.Util')
local TextManager = require('TextManager')
local DFMath = require('DFCommon.Math')
local RadFont = require('RadFont')
local RadEffects = require('RadEffects')
local AudioManager = require('AudioManager')
local Credits = {}

function Credits:UpdateThread()    
    TextManager:SetFadeAttributes( 1.0, 1.0 )

    Credits:LargeText()
    Credits:Concept()
    Credits:Core()
    Credits:Audio()
    Credits:Production()
    
    Credits:SmallText()  
    Credits:DF1()
    Credits:DF2()
    Credits:DF3()
    Credits:Dracogen()
        
    Credits:SmallText()
    Credits:SpecialThanks()
    
    Credits:LegalText()
    Credits:Legal()

    Credits:LargeText()
    Credits:ThanksForPlaying()
end

function Credits:Concept()
    DFUtil.sleep(1.0)

    local fPageDuration = 8.0    
    local fLineY = Credits.mLetterSize * -4.0
    
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "a.double.fine", Credits.mLetterSize * -6.5, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "production", Credits.mLetterSize * -5.0, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)
       
    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "concept", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )    
    TextManager:AddLine( "patrick.hackett", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "design", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize  
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "patrick.hackett", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "drew.skillman", Credits.mNameX, fLineY, fPageDuration )
    
    DFUtil.sleep(fPageDuration)
end

function Credits:Core()
    local fPageDuration = 8.0    
    local fLineY = Credits.mLetterSize * -3.5

    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "audio.director", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "brian.min", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "programming", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "ben.burbank", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "patrick.hackett", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "visual.effects", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "panya.inversin", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "drew.skillman", Credits.mNameX, fLineY, fPageDuration )
    
    DFUtil.sleep(fPageDuration)    
end

function Credits:Audio()
    local fPageDuration = 10.0    
    local fLineY = Credits.mLetterSize * -3.0

    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "audio.design", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "brian.min", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "brian.correia", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "original.music", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "brian.trifon", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "jon.shamieh", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "paul.o.rourke", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "sam.hulick", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "austin.wintory", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    DFUtil.sleep(fPageDuration)    
end

function Credits:Production()
    local fPageDuration = 8.0    
    local fLineY = Credits.mLetterSize * -3.0

    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "production", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "gabe.miller", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)
        
    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "quality.assurance", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "daniel.pangelina", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "tony.lo", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "justin.honegger", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + (Credits.mLetterSize * 1.5)
    TextManager:AddLine( "babel.media", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    DFUtil.sleep(fPageDuration)   
end

function Credits:DF1()
    local fPageDuration = 9.0    
    local fLineY = Credits.mLetterSize * -4.0
    
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "studio.creative.director", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "tim.schafer", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "director.of.product.dev", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "isa.stamos", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "vp.of.business.dev", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "justin.bailey", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "studio.technical.director", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "nathan.sun.martz", Credits.mNameX, fLineY, fPageDuration )
    
    DFUtil.sleep(fPageDuration)    
end

function Credits:DF2()
    local fPageDuration = 9.0    
    local fLineY = Credits.mLetterSize * -4.0
    
    TextManager:AddLine( "brand.manager", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "greg.rice", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "operations.manager", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "denise.gollaher", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "office.manager", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "laura.o.brien", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "office.assistant", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "allison.thomas", Credits.mNameX, fLineY, fPageDuration )
    
    DFUtil.sleep(fPageDuration)    
end

function Credits:DF3()
    local fPageDuration = 9.0    
    local fLineY = Credits.mLetterSize * -4.0
    
    TextManager:AddLine( "it", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "brent.shinn", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "justin.honegger", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "quality.assurance.manager", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "daniel.pangelina", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "quality.assurance.testers", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "tony.lo", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "victor.romero", Credits.mNameX, fLineY, fPageDuration )
    
    DFUtil.sleep(fPageDuration)    
end

function Credits:Dracogen()
    local fPageDuration = 9.0   
    local fLineY = Credits.mLetterSize * -6.0 
    
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "dracogen.inc", Credits.mLetterSize * -6.0, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize + Credits.mLetterSize
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "founder.and.ceo", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "steven.dengler", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mBreakSleep
    DFUtil.sleep(Credits.mBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mLetterSize
    TextManager:AddLine( "dracogen.would.like.to.thank", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "bruna.pace", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "raffaele.dengler", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "beric.dengler", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "double.fine", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "ash.vickers.and.megacynics_com", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "friends.and.family", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    DFUtil.sleep(fPageDuration)  
end
    
function Credits:SpecialThanks()
    local fPageDuration = 12.0    
    local fLineY = Credits.mLetterSize * -6.0
    
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color3 )
    TextManager:AddLine( "special.thanks", Credits.mTitleX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "rhoda.bagorio", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "avinash.dabir", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "david.holz", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "michael.buckwald", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "andy.miller", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "will.wright", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "jesse.johansen", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "katrina.haus", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)    
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "jess.burbank", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)    
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "katrina.tilds", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "darren.lund", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)    
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "david.jenkins", Credits.mNameX, fLineY, fPageDuration )
    fPageDuration = fPageDuration - Credits.mStandardSleep
    DFUtil.sleep(Credits.mStandardSleep)    
    
    DFUtil.sleep(fPageDuration)        
end

function Credits:Legal()
    local fPageDuration = 9.0    
    local fLineY = Credits.mLetterSize * -6.5
    
    local fLegalSleep = Credits.mStandardSleep * 0.5
    local fLegalBreakSleep = Credits.mBreakSleep
    
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "dropchord_.double.fine.productions_", Credits.mLetterSize * -17.5, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "and.the.double.fine.logo.are.the", Credits.mLetterSize * -16.0, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "exclusive.trademarks.of.double.fine", Credits.mLetterSize * -17.5, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "productions_.inc..all.rights.reserved", Credits.mLetterSize * -18.5, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalBreakSleep
    DFUtil.sleep(fLegalBreakSleep)
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "the.dracogen.word.and.logos.are", Credits.mLetterSize * -15.0, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "copyrighted.trade.marks.of.dracogen.inc", Credits.mLetterSize * -19.0, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "all.rights.reserved.worldwide", Credits.mLetterSize * -14.0, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalBreakSleep
    DFUtil.sleep(fLegalBreakSleep)    
    
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "fmod.ex.sound.system.copyright", Credits.mLetterSize * -15.0, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "2001_2013.firelight.technologies.pty.ltf", Credits.mLetterSize * -20.0, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "all.rights.reserved", Credits.mLetterSize * -9.5, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalBreakSleep
    DFUtil.sleep(fLegalBreakSleep)

    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    TextManager:AddLine( "made.with.moai", Credits.mLetterSize * -7.0, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "copyright.2010_2013.zipline.games.inc", Credits.mLetterSize * -18.5, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize + Credits.mSmallBuff
    fPageDuration = fPageDuration - fLegalSleep
    DFUtil.sleep(fLegalSleep)    
    TextManager:AddLine( "all.rights.reserved", Credits.mLetterSize * -9.5, fLineY, fPageDuration )
    
    DFUtil.sleep(fPageDuration)      
end

function Credits:ThanksForPlaying()
    local fPageDuration = 6.0    
    local fLineY = -Credits.mLetterSize
    
    TextManager:SetTextAttributes( Credits.mLetterSize, Credits.mLetterScale, Constants.Color1 )
    TextManager:AddLine( "thanks.for", Credits.mLetterSize * -5.0, fLineY, fPageDuration )
    fLineY = fLineY + Credits.mLetterSize
    TextManager:AddLine( "playing!", Credits.mLetterSize * -4.0, fLineY, fPageDuration )
    
    DFUtil.sleep(fPageDuration)  
end

function Credits:Init()
    Credits.mUpdateThread = nil

    Credits.mStandardSleep = 0.5
    Credits.mBreakSleep = 1.0

    Credits.mLetterScale = 1.0
    Credits.mLetterSize = 1.0
    Credits.mTitleX = 1.0
    Credits.mNameX = 1.0  
    Credits.mSmallBuff = 1.0
            
    Credits:LargeText()
end

function Credits:LargeText()
    local fDesiredLetterSize = Constants.ValidDrawHeight / 30.0
    Credits.mLetterScale = fDesiredLetterSize / 128.0
    Credits.mLetterSize = fDesiredLetterSize
    
    Credits.mTitleX = Credits.mLetterSize * -9.0
    Credits.mNameX = Credits.mTitleX + (Credits.mLetterSize * 3.0)    
    Credits.mSmallBuff = Credits.mLetterSize * 0.2  
end

function Credits:SmallText()
    local fDesiredLetterSize = Constants.ValidDrawHeight / 40.0
    Credits.mLetterScale = fDesiredLetterSize / 128.0
    Credits.mLetterSize = fDesiredLetterSize
    
    Credits.mTitleX = Credits.mLetterSize * -12.0
    Credits.mNameX = Credits.mTitleX + (Credits.mLetterSize * 3.0)    
    Credits.mSmallBuff = Credits.mLetterSize * 0.2
end

function Credits:LegalText()
    local fDesiredLetterSize = Constants.ValidDrawHeight / 50.0
    Credits.mLetterScale = fDesiredLetterSize / 128.0
    Credits.mLetterSize = fDesiredLetterSize
    
    Credits.mTitleX = Credits.mLetterSize * -12.0
    Credits.mNameX = Credits.mTitleX + (Credits.mLetterSize * 3.0)    
    Credits.mSmallBuff = Credits.mLetterSize * 0.2
end

function Credits:UpdateSize( tRenderer )
    if Credits:AreCreditsShowing() then
        Credits:EndCredits( tRenderer )
    end
end

function Credits:BeginCredits( tRenderer )
    if Credits.mUpdateThread == nil then
        Credits.mUpdateThread = MOAIThread.new()
        Credits.mUpdateThread:run(Credits.UpdateThread, Credits)
    end
    
    --create header props
    local sText = "credits"
    local textWalker = string.gmatch(sText, ".")
    Credits.mHeaderTextCount = #sText
    
    Credits.mHeaderImageSize = Constants.ValidDrawHeight / 20.0
    Credits.mHeaderImageScale = Credits.mHeaderImageSize / 128.0    
    Credits.mHeaderTextProps = {}
    
    local fXPos = -(Credits.mHeaderImageSize * (Credits.mHeaderTextCount + 2))
    local fYPos = Constants.ValidDrawHeight * -.2
    local fZPos = 2.0
    
    local i = 1
    local j = 1
    for i = 1, Credits.mHeaderTextCount do
        Credits.mHeaderTextProps[i] = MOAIProp.new()
        Credits.mHeaderTextProps[i]:setDeck( RadFont.mFontDeck )        
        Credits.mHeaderTextProps[i]:setScl( Credits.mHeaderImageScale, -Credits.mHeaderImageScale )
        Credits.mHeaderTextProps[i]:setIndex( RadFont.mFontDeck.names[ textWalker() ] )
        Credits.mHeaderTextProps[i]:setLoc( fXPos, fYPos, fZPos )
        Credits.mHeaderTextProps[i]:setColor( Constants.Color1[1], Constants.Color1[2], Constants.Color1[3], 1.0 )
        Credits.mHeaderTextProps[i]:setBlendMode( MOAIProp2D.GL_SRC_ALPHA, MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA )
        Credits.mHeaderTextProps[i]:setVisible( true )
        
        tRenderer.mUILayer:insertProp( Credits.mHeaderTextProps[i] )        
        
        fXPos = fXPos + Credits.mHeaderImageSize
    end    
    
    Credits.mMenuTextSize = Constants.ValidDrawHeight / 30.0
    Credits.mMenuTextScale = Credits.mMenuTextSize / 128.0
    Credits.mMenuTextHighlightSize = Credits.mMenuTextSize * 1.2
    Credits.mMenuTextHighlightScale = Credits.mMenuTextScale * 1.2
    Credits.mMenuTextHalfDiff = (Credits.mMenuTextHighlightSize - Credits.mMenuTextSize) * 0.5
    
    Credits.mMenuXPos = Credits.mMenuTextSize * -16.0
    Credits.mMenuWidth = Credits.mMenuTextSize * 5.0
    Credits.mMenuYPos = Constants.ValidDrawHeight * .3
    
    local menuText = "back"
    local menuTextWalker = string.gmatch(menuText, ".")
    Credits.mMenuTextCount = 4
    Credits.mMenuTextProps = {}
    
    for i = 1, Credits.mMenuTextCount do
        Credits.mMenuTextProps[i] = {}
        local iIndex = menuTextWalker()
        for j = 1, 2 do
            Credits.mMenuTextProps[i][j] = MOAIProp.new()
            Credits.mMenuTextProps[i][j]:setDeck( RadFont.mFontDeck )        
            Credits.mMenuTextProps[i][j]:setScl( Credits.mMenuTextScale, -Credits.mMenuTextScale )
            Credits.mMenuTextProps[i][j]:setIndex( RadFont.mFontDeck.names[iIndex] )
            Credits.mMenuTextProps[i][j]:setVisible( true )
            Credits.mMenuTextProps[i][j]:setBlendMode( MOAIProp2D.GL_SRC_ALPHA, MOAIProp2D.GL_ONE_MINUS_SRC_ALPHA )
            Credits.mMenuTextProps[i][j]:setColor( 1.0, 1.0, 1.0, 1.0 )
            Credits.mMenuTextProps[i][j]:setLoc( Credits.mMenuXPos + ((i-1) * Credits.mMenuTextSize), Credits.mMenuYPos, fZPos )
            
            tRenderer.mUILayer:insertProp( Credits.mMenuTextProps[i][j] )        
        end
    end      
    
    Credits.mEffectsZ = 20.0
    Credits.mFingerEffects = {}
    for i = 1, 2 do
        Credits.mFingerEffects[i] = RadEffects:NewFingerEffect("Effects/Particles/Fingers/HowTo.particles", false)
        if Credits.mFingerEffects[i] then
            local fingerEffectProp = Credits.mFingerEffects[i]:getProp()
            Credits.mFingerEffects[i]:setTargetProp(fingerEffectProp)        
            Credits.mFingerEffects[i]:setVisible(false)
        end        
    end    
end

function Credits:Update( tGameInputs )
    --don't bother if our thread isn't active
    if Credits.mUpdateThread ~= nil then
        local i = 1    
        for i = 1, 2 do
            if tGameInputs[i].IsTouched() then            
                if Credits.mFingerEffects[i] then
                    local fingerEffectProp = Credits.mFingerEffects[i]:getProp()
                    fingerEffectProp:setLoc( tGameInputs[i].mX, tGameInputs[i].mY, Credits.mEffectsZ )
                    Credits.mFingerEffects[i]:setVisible( true )
                end            
            else
                if Credits.mFingerEffects[i] then
                    Credits.mFingerEffects[i]:setVisible( false )
                end             
            end
        end
        
        --see if we tapped exit
        local bSelectionValid = false
        local bExit = false
        
        local yMin = Credits.mMenuYPos - (Credits.mMenuTextSize * 4.0)
        local yMax = Credits.mMenuYPos + Credits.mMenuTextSize
            
        for i = 1, 2 do                    
            if tGameInputs[i].mY > yMin and tGameInputs[i].mY < yMax then
                local fMenuMinX = Credits.mMenuXPos - Credits.mMenuTextSize
                local fMenuMaxX = Credits.mMenuXPos + Credits.mMenuWidth + (Credits.mMenuTextSize * 2.0)
                
                if tGameInputs[i].mX > fMenuMinX and tGameInputs[i].mX < fMenuMaxX then
                    if tGameInputs[i].IsTouched() then
                        bSelectionValid = true
                        break
                    end
        
                    if tGameInputs[i].WasTouched() then
                        bExit = true
                        break
                    end
                end
            end
        end
        Credits:PositionEsc( bSelectionValid )
        
        if bExit then
            AudioManager:PlaySound( 'Radius/SFX/MenuSelect' )  
            return true
        end
    end    
    
    return false
end

function Credits:PositionEsc( bDepressed )
    local fDepressedOffset = Credits.mLetterSize * 0.15
    if bDepressed then
        fDepressedOffset = Credits.mLetterSize * 0.075
    end
    
    local i = 1
    local j = 1
    for i = 1, Credits.mMenuTextCount do
        Credits.mMenuTextProps[i][1]:setColor( 0.0, 0.0, 0.0, 0.25 )
        local x = Credits.mMenuXPos + ((i-1) * Credits.mMenuTextSize)
        Credits.mMenuTextProps[i][1]:setLoc( x - fDepressedOffset, Credits.mMenuYPos + fDepressedOffset, 0.0 )    
        Credits.mMenuTextProps[i][2]:setLoc( x + fDepressedOffset, Credits.mMenuYPos - fDepressedOffset, 2.0 ) 
    end
end

function Credits:AreCreditsShowing()
    if Credits.mUpdateThread == nil then
        return false
    end
    return Credits.mUpdateThread:isDone() or Credits.mUpdateThread:isBusy()
end

function Credits:EndCredits( tRenderer )
    if Credits.mUpdateThread ~= nil then
        Credits.mUpdateThread:stop()
        Credits.mUpdateThread = nil
    end
    
    local i = 1
    local j = 1
    for i = 1, Credits.mHeaderTextCount do
        tRenderer.mUILayer:removeProp( Credits.mHeaderTextProps[i] )
    end     
    
    for i = 1, Credits.mMenuTextCount do
        for j = 1, 2 do
            tRenderer.mUILayer:removeProp( Credits.mMenuTextProps[i][j] )
        end
    end
    
    for i = 1, 2 do
        if Credits.mFingerEffects[i] then    
            Credits.mFingerEffects[i]:stop(false)
        end
        Credits.mFingerEffects[i] = nil      
    end    
end

return Credits