local DFGraphics = require("DFCommon.Graphics")
local Constants = require("Constants")
local Letterbox = {}

function Letterbox:new(rLayer)
    local Ob = {}

    Ob.mLayer = rLayer
    
    function Ob:OnScreenResize(width, height)
        local aspectRatio = width / height
        
        local barSize = (height - Constants.ValidDrawHeight) / 2
        
        --print("aspectRatio: " .. tostring(aspectRatio))
    
        self.mBox1:setLoc(-width/2, -height/2, 1)
        self.mBox1:setScl(width * 2, barSize)
        
        self.mBox2:setLoc(-width/2, height/2, 1)
        self.mBox2:setScl(width * 2, barSize)
    end
        
    local quadDeck = MOAIGfxQuad2D.new()
    local whiteTexture = DFGraphics.loadTexture( "White", true )
    quadDeck:setTexture( whiteTexture )
    quadDeck:setRect( -1, -1, 1, 1 )
    Ob.mBox1 = MOAIProp2D.new()
    Ob.mBox1.__typename = "Letterbox"
    Ob.mBox1:setDeck( quadDeck )
    Ob.mBox1:setColor(Constants.LetterboxColor[1],Constants.LetterboxColor[2],Constants.LetterboxColor[3],Constants.LetterboxColor[4])
    
    
    Ob.mBox2 = MOAIProp2D.new()
    Ob.mBox2.__typename = "Letterbox"
    Ob.mBox2:setDeck( quadDeck )
    Ob.mBox2:setColor(Constants.LetterboxColor[1],Constants.LetterboxColor[2],Constants.LetterboxColor[3],Constants.LetterboxColor[4])
    
    if Constants.LetterboxColor[4] > 0.001 then
        --Ob.mLayer:insertProp(Ob.mBox1)  
        --Ob.mLayer:insertProp(Ob.mBox2)  
    end
        
    return Ob
end


return Letterbox