local Post = require('postfx.Post')
local Renderer = require('Renderer')
local DFGraphics = require('DFCommon.Graphics')
local DFFile = require('DFCommon.File')
local Constants = require('Constants')
local ChargeField= require('ChargeField')
local Grid = require('Grid')
local GlowRing = require('GlowRing')
local HUDGlow = require('HUDGlow')
local ColorManager= require('ColorManager')
local DFMath = require('DFCommon.Math')

local PostStateGameOver = {}

function PostStateGameOver:Start()
    print("PostStateGameOver: Start")
    Post:Reset()

    Post:SetUpdateCallback(PostStateGameOver.Update)
    
    -----------------------------------------------
    -- Setup Colors 
    -----------------------------------------------      
    ColorManager.BGColor            = {0,0,0}
    ColorManager.Color1             = {.75, .34, .9}
    ColorManager.Color2             = {.1, .0, .28} --score
    ColorManager.Color3             = {.75, .34, .9} --multiplier
    ColorManager:SetColor()
    
    ChargeField:Enable(true)
    ChargeField:SetColor(.1,.1,.1,1)
    ChargeField.mChargeFieldDeck:SetRestoreScalar( 3.0 )
    ChargeField.mChargeFieldDeck:SetPointWidth( 0.0, 4.0 )
    ChargeField.mChargeFieldDeck:SetActivatedDistance( 60.0 )

    Post:EnableFullscreenEffects(false)
end

return PostStateGameOver