local Post = require('postfx.Post')
local Renderer = require('Renderer')
local DFGraphics = require('DFCommon.Graphics')
local DFFile = require('DFCommon.File')
local Constants = require('Constants')
local ChargeField= require('ChargeField')
local Grid = require('Grid')
local GlowRing = require('GlowRing')
local HUDGlow = require('HUDGlow')
local ColorManager= require('ColorManager')
local DFMath = require('DFCommon.Math')
local RadEffects = require('RadEffects')
local ChargeManager = require('ChargeManager')

local PostStateIntro = {}

local flowIntensity = nil
local totalTime = nil
local audioAverage = 0.0

function PostStateIntro:Start()
    print("PostStateIntro: Start")
    Post:Reset()
    
    totalTime = 0.0 
    flowIntensity = 0.0
    
    Post:SetUpdateCallback(PostStateIntro.IntroUpdate) 
    
    -----------------------------------------------
    -- Setup Colors 
    -----------------------------------------------      
    ColorManager.BGColor            = {0.0, 0.0, 0.0}
    ColorManager.Color1             = {1.0, 0.5, 0.1}
    ColorManager.Color2             = {0.8, 0.3, 0.0} 
    ColorManager.Color3             = {0.0, 0.05, 0.3} 
    ColorManager.SpecialColor       = {0.8, 0.3, 0.0} 
    ColorManager:SetColor()
    
    Grid:SetColor(.1,.1,.1, 1)
    Grid:Enable(true)
    Grid.mGridDeck:SetPointWidth( 2 )
    Grid.mGridDeck:SetSpringK( 1.0 )
    Grid.mGridDeck:SetSpringDampen( 0.02 )
    
    Post:EnableFullscreenEffects(false)
end

function PostStateIntro.IntroUpdate()
    flowIntensity = flowIntensity + Constants.FrameStep*.01
    totalTime = totalTime + Constants.FrameStep
    flowIntensity = DFMath.pin(flowIntensity, 0.0, .025)
    local blitIntensity = .5 + (math.sin(totalTime*10) + 1) * .2
    
    audioAverage = DFMath.lerp( 1.0 * Constants.tAudioSpectrum[3], audioAverage, 0)    
end

return PostStateIntro