local Post = require('postfx.Post')
local Renderer = require('Renderer')
local DFGraphics = require('DFCommon.Graphics')
local DFFile = require('DFCommon.File')
local Constants = require('Constants')
local ChargeField= require('ChargeField')
local Grid = require('Grid')
local GlowRing = require('GlowRing')
local HUDGlow = require('HUDGlow')
local Wind = require('Wind')
local Score = require('Score')
local ColorManager= require('ColorManager')
local DFMath = require('DFCommon.Math')
local ParticleSystem = require("ParticleSystem")
local RadEffects = require('RadEffects')
local PostState_Leaderboards= {}

local totalTime = 0.0
local audioSmoothed = 0.0

function PostState_Leaderboards:Reset()
    -- wwwwwwwwwwwwwwwwwwwwwwwwwwww
end

function PostState_Leaderboards.Update()
    local level_intensity = .5

    totalTime = totalTime  + Constants.FrameStep
end

function PostState_Leaderboards:Start()
    print("PostState_Leaderboards: Start")
    Post:Reset()
    PostState_Leaderboards:Reset()
    
    Post:SetUpdateCallback(PostState_Leaderboards.Update)   
    
    ColorManager.BGColor            = {0,0,0}
    ColorManager.Color1             = {.3, .25, .7}
    ColorManager.Color2             = {.8, .3, .05} --score
    ColorManager.Color3             = {.0, .34, .2} --multiplier
    ColorManager:SetColor()
    
    ChargeField:Enable(false)
    ChargeField:SetColor(.1,.2,.1,1)
    ChargeField.mChargeFieldDeck:SetRestoreScalar( 3.0 )
    ChargeField.mChargeFieldDeck:SetPointWidth( 0.0, 5.0 )
    ChargeField.mChargeFieldDeck:SetActivatedDistance( 120.0 )

    RadEffects:SetGoodExplosionCallback(RadEffects.SpawnBubbleChamber)
    RadEffects.particleAccumLayer = particleLayer
    
    Post:EnableFullscreenEffects(false)
end


return PostState_Leaderboards